# Note that this is NOT a relocatable package
%define ver      0.15
%define rel      SNAP
%define prefix   /usr/local

Summary: Enlightenment Window Manager
Name: enlightenment
Version: %ver
Release: %rel
Copyright: GPL
Group: X11/Applications
Source: ftp://www.rasterman.com/pub/enlightenment/enlightenment-%{ver}.tar.gz
BuildRoot: /tmp/e-root
Packager: The Rasterman <raster@redhat.com>
URL: http://www.rasterman.com/
Requires: imlib >= 1.8
Requires: fnlib >= 0.3
Requires: freetype >= 1.1
Requires: esound >= 0.2.4


Docdir: %{prefix}/doc

%description
Enlightenment is a Windowmanager for the X Windowing System that is 
designed to be powerful, extensible, configurable and able to be really 
good looking.

%changelog

* Fri Nov 20 1998 Michael Fulbright <drmike@redhat.com>

- updated for pre-dr15

* Fri Sep 11 1998 Mandrake <mandrake@mandrake.net>

- changed rev num, also incremented imlib requirement to 1.8

* Tue Jun 2 1998 The Rasterman <raster@redhat.com>

- wrote .spec file


%prep
%setup

%build
# Optimize that damned code all the way
if [ ! -z "`echo -n ${RPM_OPT_FLAGS} | grep pentium`" ]; then
  if [ ! -z `which egcs` ]; then
    CC="egcs" 
  else
    if [ ! -z `which pgcc` ]; then
      CC="pgcc"
    fi
  fi
  CFLAGS="${RPM_OPT_FLAGS}"
else
  CFLAGS="${RPM_OPT_FLAGS}"
fi
if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh --prefix=%prefix --enable-fsstd
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%prefix --enable-fsstd
fi

make

%install
rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT%{prefix} install

%clean
rm -rf $RPM_BUILD_ROOT

%post

%postun

%files
%defattr(-, root, root)

%{prefix}/share/enlightenment/*
%{prefix}/bin/*

%doc doc/AUTHORS
%doc doc/COPYING
%doc doc/INSTALL
%doc doc/ChangeLog
%doc doc/NEWS
%doc doc/README
%doc doc/FAQ
%doc doc/TODO
