#include "E.h"

static int          area_w = 3;
static int          area_h = 3;

#define AREA_FIX(ax, ay) \
if (ax < 0) \
ax = 0; \
else if (ax >= area_w) \
ax = area_w - 1; \
if (ay < 0) \
ay = 0; \
else if (ay >= area_h) \
ay = area_h - 1;

void
GetCurrentArea(int *ax, int *ay)
{
  EDBUG(4, "GetCurrentArea");
  *ax = desks.desk[desks.current].current_area_x;
  *ay = desks.desk[desks.current].current_area_y;
  EDBUG_RETURN_;
}

void
SetAreaSize(int aw, int ah)
{
  EDBUG(4, "SetAreaSize");
  if (aw < 1)
    aw = 1;
  if (ah < 1)
    ah = 1;
  area_w = aw;
  area_h = ah;
  GNOME_SetAreaCount();
  EDBUG_RETURN_;
}

void
GetAreaSize(int *aw, int *ah)
{
  EDBUG(4, "GetAreaSize");
  *aw = area_w;
  *ah = area_h;
  EDBUG_RETURN_;
}

void
InitCurrentArea(int ax, int ay)
{
  EDBUG(4, "InitCurrentArea");
  AREA_FIX(ax, ay);
  desks.desk[desks.current].current_area_x = ax;
  desks.desk[desks.current].current_area_y = ay;
  EDBUG_RETURN_;
}

void
SetCurentArea(int ax, int ay)
{
  EWin              **lst;
  int                 i, num, a1, a2;

  EDBUG(4, "SetCurentArea");
  AREA_FIX(ax, ay);
  if ((ax == desks.desk[desks.current].current_area_x) &&
      (ay == desks.desk[desks.current].current_area_y))
    EDBUG_RETURN_;
  lst = (EWin **) ListItemType(&num, LIST_TYPE_EWIN);
  if (lst)
    {
      for (i = 0; i < num; i++)
	{
	  if ((lst[i]->desktop == desks.current) &&
	      (!lst[i]->sticky) && (!lst[i]->floating) &&
	      (!lst[i]->fixedpos))
	    {
	      a1 = lst[i]->area_x;
	      a2 = lst[i]->area_y;
	      MoveEwin(lst[i],
		       lst[i]->x - (root.w * (ax - desks.desk[desks.current].current_area_x)),
		       lst[i]->y - (root.h * (ay - desks.desk[desks.current].current_area_y)));
	      lst[i]->area_x = a1;
	      lst[i]->area_y = a2;
	      ICCCM_Configure(lst[i]);
	    }
	}
      Efree(lst);
    }
  desks.desk[desks.current].current_area_x = ax;
  desks.desk[desks.current].current_area_y = ay;
  GNOME_SetCurrentArea();
  EDBUG_RETURN_;
}

void
MoveEwinToArea(EWin * ewin, int ax, int ay)
{
  EDBUG(4, "MoveEwinToArea");
  AREA_FIX(ax, ay);
  MoveEwin(ewin, ewin->x + (root.w * (ax - ewin->area_x)),
	   ewin->y + (root.h * (ay - ewin->area_y)));
  ewin->area_x = ax;
  ewin->area_y = ay;
  ICCCM_Configure(ewin);
  EDBUG_RETURN_;
}

void
SetEwinToCurrentArea(EWin * ewin)
{
  EDBUG(4, "SetEwinToCurrentArea");
  ewin->area_x = desks.desk[ewin->desktop].current_area_x;
  ewin->area_y = desks.desk[ewin->desktop].current_area_y;
  EDBUG_RETURN_;
}

void
MoveCurrentAreaBy(int ax, int ay)
{
  EDBUG(4, "MoveCurrentAreaBy");
  SetCurentArea(desks.desk[desks.current].current_area_x + ax,
		desks.desk[desks.current].current_area_y + ay);
  EDBUG_RETURN_;
}
