#include "E.h"

HandleStruct        HArray[] =
{
  {DefaultFunc},
  {DefaultFunc},
  {HKeyPress},
  {HKeyRelease},
  {HButtonPress},
  {HButtonRelease},
  {HMotionNotify},
  {HEnterNotify},
  {HLeaveNotify},
  {HFocusIn},
  {HFocusOut},
  {HKeymapNotify},
  {HExpose},
  {HGraphicsExpose},
  {HNoExpose},
  {HVisibilityNotify},
  {HCreateNotify},
  {HDestroyNotify},
  {HUnmapNotify},
  {HMapNotify},
  {HMapRequest},
  {HReparentNotify},
  {HConfigureNotify},
  {HConfigureRequest},
  {HGravityNotify},
  {HResizeRequest},
  {HCirculateNotify},
  {HCirculateRequest},
  {HPropertyNotify},
  {HSelectionClear},
  {HSelectionRequest},
  {HSelectionNotify},
  {HColormapNotify},
  {HClientMessage},
  {HMappingNotify},
  {DefaultFunc}
};

void
DebugEvent(XEvent * ev)
{
  EDBUG(8, "DebugEvent");
  if (ev->type == event_base_shape + ShapeNotify)
    printf("EV: ShapeNotify:\n");
  else
    {
      switch (ev->type)
	{
	case KeyPress:
	  printf("EV: KeyPress:\n");
	  break;
	case KeyRelease:
	  printf("EV: KeyRelease:\n");
	  break;
	case ButtonPress:
	  printf("EV: ButtonPress:\n");
	  break;
	case ButtonRelease:
	  printf("EV: ButtonRelease:\n");
	  break;
	case MotionNotify:
	  printf("EV: MotionNotify:\n");
	  break;
	case EnterNotify:
	  printf("EV: EnterNotify:\n");
	  break;
	case LeaveNotify:
	  printf("EV: LeaveNotify:\n");
	  break;
	case FocusIn:
	  printf("EV: FocusIn:\n");
	  break;
	case FocusOut:
	  printf("EV: FocusOut:\n");
	  break;
	case KeymapNotify:
	  printf("EV: KeymapNotify:\n");
	  break;
	case Expose:
	  printf("EV: Expose:\n");
	  break;
	case GraphicsExpose:
	  printf("EV: GraphicsExpose:\n");
	  break;
	case NoExpose:
	  printf("EV: NoExpose:\n");
	  break;
	case VisibilityNotify:
	  printf("EV: VisibilityNotify:\n");
	  break;
	case CreateNotify:
	  printf("EV: CreateNotify:\n");
	  break;
	case DestroyNotify:
	  printf("EV: DestroyNotify:\n");
	  break;
	case UnmapNotify:
	  printf("EV: UnmapNotify:\n");
	  break;
	case MapNotify:
	  printf("EV: MapNotify:\n");
	  break;
	case MapRequest:
	  printf("EV: MapRequest:\n");
	  break;
	case ReparentNotify:
	  printf("EV: ReparentNotify:\n");
	  break;
	case ConfigureNotify:
	  printf("EV: ConfigureNotify:\n");
	  break;
	case ConfigureRequest:
	  printf("EV: ConfigureRequest:\n");
	  break;
	case GravityNotify:
	  printf("EV: GravityNotify:\n");
	  break;
	case ResizeRequest:
	  printf("EV: ResizeRequest:\n");
	  break;
	case CirculateNotify:
	  printf("EV: CirculateNotify:\n");
	  break;
	case CirculateRequest:
	  printf("EV: CirculateRequest:\n");
	  break;
	case PropertyNotify:
	  printf("EV: PropertyNotify:\n");
	  break;
	case SelectionClear:
	  printf("EV: SelectionClear:\n");
	  break;
	case SelectionRequest:
	  printf("EV: SelectionRequest:\n");
	  break;
	case SelectionNotify:
	  printf("EV: SelectionNotify:\n");
	  break;
	case ColormapNotify:
	  printf("EV: ColormapNotify:\n");
	  break;
	case ClientMessage:
	  printf("EV: ClientMessage:\n");
	  break;
	case MappingNotify:
	  printf("EV: MappingNotify:\n");
	  break;
	default:
	  printf("EV: ???\n");
	  break;
	}
    }
  EDBUG_RETURN_;
}

void
HandleEvent(XEvent * ev)
{
  void              **lst;
  int                 i, num;

  EDBUG(7, "HandleEvent");
/*  DebugEvent(ev); */
  if (ev->type == event_base_shape + ShapeNotify)
    HandleChildShapeChange(ev);
  lst = ListItemType(&num, LIST_TYPE_ACLASS_GLOBAL);
  if (lst)
    {
      for (i = 0; i < num; i++)
	EventAclass(ev, (ActionClass *) lst[i]);
      Efree(lst);
    }
  if (ev->type <= 35)
    HArray[ev->type].func(ev);

  EDBUG_RETURN_;
}

void
CheckEvent()
{
  XEvent              ev;

  EDBUG(7, "CheckEvent");
  while (XPending(disp))
    {
      XNextEvent(disp, &ev);
      HandleEvent(&ev);
    }
  EDBUG_RETURN_;
}

void
WaitEvent()
{
  XEvent              ev;
  fd_set              fdset;
  struct timeval      tval;
  static struct timeval tval_last =
  {0, 0};
  double              time1, time2;
  Qentry             *qe;
  int                 count;

  EDBUG(7, "WaitEvent");
  /* if we've never set the time we were last here before */
  if ((tval_last.tv_sec == 0) && (tval_last.tv_usec == 0))
    {
      gettimeofday(&tval_last, NULL);
    }
  /* time1 = time we last entered this routine */
  time1 = ((double)tval_last.tv_sec) + (((double)tval_last.tv_usec) / 1000000);
  gettimeofday(&tval, NULL);
  tval_last.tv_sec = tval.tv_sec;
  tval_last.tv_usec = tval.tv_usec;
  /* time2 = current time */
  time2 = ((double)tval.tv_sec) + (((double)tval.tv_usec) / 1000000);
  time2 -= time1;
  if (time2 < 0.0)
    time2 = 0.0;
  /* time2 = time spent since we last were here */
  count = 0;
  fflush(stdout);
  fflush(stderr);
  while (XPending(disp))
    {
      XNextEvent(disp, &ev);
      HandleEvent(&ev);
    }
  HandleDrawQueue();
  XSync(disp, False);
  while (XPending(disp))
    {
      XNextEvent(disp, &ev);
      HandleEvent(&ev);
    }
  FD_ZERO(&fdset);
  FD_SET(ConnectionNumber(disp), &fdset);
  if (GetSMfd() >= 0)
    FD_SET(GetSMfd(), &fdset);
  qe = GetHeadTimerQueue();
  if (qe)
    {
      if (qe->just_added)
	{
	  qe->just_added = 0;
	  time1 = qe->in_time;
	}
      else
	{
	  time1 = qe->in_time - time2;
	  if (time1 < 0.0)
	    time1 = 0.0;
	  qe->in_time = time1;
	}
      tval.tv_sec = (long)time1;
      tval.tv_usec = (long)((time1 - ((double)tval.tv_sec)) * 1000000);
      select(sizeof(fdset) * 8, &fdset, NULL, NULL, &tval);
    }
  else
    select(sizeof(fdset) * 8, &fdset, NULL, NULL, NULL);
  if (GetSMfd() >= 0)
    {
      if (FD_ISSET(GetSMfd(), &fdset))
	ProcessICEMSGS();
    }
  if (!(FD_ISSET(ConnectionNumber(disp), &fdset)) && (qe))
    HandleTimerEvent();
  EDBUG_RETURN_;
}

void
HKeyPress(XEvent * ev)
{
  EDBUG(7, "HKeyPress");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HKeyRelease(XEvent * ev)
{
  EDBUG(7, "HKeyRelease");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HButtonPress(XEvent * ev)
{
  EDBUG(7, "HButtonPress");
  ApplySclass(FindItem("SOUND_BUTTON_CLICK", 0,
		       LIST_FINDBY_NAME, LIST_TYPE_SCLASS));
  HandleMouseDown(ev);
  DesktopAccounting();
/*  
 * {
 * char **s;
 * int i, num;
 * 
 * s = ListItems(&num, LIST_TYPE_ANY);
 * if (s)
 * {
 * for (i = 0; i < num; i++)
 * printf("%s\n", s[i]);
 * freestrlist(s, num);
 * }
 * } */
  EDisplayMemUse();
  EDBUG_RETURN_;
}

void
HButtonRelease(XEvent * ev)
{
  EDBUG(7, "HButtonRelease");
  ApplySclass(FindItem("SOUND_BUTTON_RAISE", 0,
		       LIST_FINDBY_NAME, LIST_TYPE_SCLASS));
  HandleMouseUp(ev);
  EDBUG_RETURN_;
}

void
HMotionNotify(XEvent * ev)
{
  EDBUG(7, "HMotionNotify");
  while (XCheckTypedEvent(disp, ev->type, ev));
  HandleMotion(ev);
  EDBUG_RETURN_;
}

void
HEnterNotify(XEvent * ev)
{
  XEvent              ev2;

  EDBUG(7, "HEnterNotify");
  if (mode.mode == MODE_NONE)
    {
      if (XEventsQueued(disp, QueuedAfterFlush) > 0)
	{
	  XNextEvent(disp, &ev2);
	  if (!((ev2.type == LeaveNotify) &&
		(ev2.xcrossing.window == ev->xcrossing.window)))
	    {
	      HandleMouseIn(ev);
	      HandleFocusWindow(ev->xcrossing.window);
	      HandleEvent(&ev2);
	    }
	}
      else
	{
	  HandleMouseIn(ev);
	  HandleFocusWindow(ev->xcrossing.window);
	}
    }
  EDBUG_RETURN_;
}

void
HLeaveNotify(XEvent * ev)
{
  EDBUG(7, "HLeaveNotify");
  if (mode.mode == MODE_NONE)
    {
      HandleMouseOut(ev);
      HandleFocusWindow(ev->xcrossing.window);
    }
  EDBUG_RETURN_;
}

void
HFocusIn(XEvent * ev)
{
  EDBUG(7, "HFocusIn");
  if (ev->xfocus.detail != NotifyPointer)
    HandleFocusWindowIn(ev->xfocus.window);
  ev = NULL;
  EDBUG_RETURN_;
}

void
HFocusOut(XEvent * ev)
{
  EDBUG(7, "HFocusOut");
/*  HandleFocusWindow(ev->xfocus.window); */
  ev = NULL;
  EDBUG_RETURN_;
}

void
HKeymapNotify(XEvent * ev)
{
  EDBUG(7, "HKeymapNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HExpose(XEvent * ev)
{
  EDBUG(7, "HExpose");
  if (!ev->xexpose.count)
    HandleExpose(ev);
  EDBUG_RETURN_;
}

void
HGraphicsExpose(XEvent * ev)
{
  EDBUG(7, "HGraphicsExpose");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HNoExpose(XEvent * ev)
{
  EDBUG(7, "HNoExpose");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HVisibilityNotify(XEvent * ev)
{
  EDBUG(7, "HVisibilityNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HCreateNotify(XEvent * ev)
{
  EDBUG(7, "HCreateNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HDestroyNotify(XEvent * ev)
{
  EDBUG(7, "HDestroyNotify");
  HandleDestroy(ev);
  DesktopAccounting();
  EDBUG_RETURN_;
}

void
HUnmapNotify(XEvent * ev)
{
  EDBUG(7, "HUnmapNotify");
  HandleUnmap(ev);
  DesktopAccounting();
  EDBUG_RETURN_;
}

void
HMapNotify(XEvent * ev)
{
  EDBUG(7, "HMapNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HMapRequest(XEvent * ev)
{
  EDBUG(7, "HMapRequest");
  HandleMapRequest(ev);
  DesktopAccounting();
  EDBUG_RETURN_;
}

void
HReparentNotify(XEvent * ev)
{
  EDBUG(7, "HReparentNotify");
  HandleReparent(ev);
  EDBUG_RETURN_;
}

void
HConfigureNotify(XEvent * ev)
{
  EDBUG(7, "HConfigureNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HConfigureRequest(XEvent * ev)
{
  unsigned long       mask;
  XEvent              ev2;

  EDBUG(7, "HConfigureRequest");
  mask = ev->xconfigurerequest.value_mask;
  if (XCheckTypedWindowEvent(disp, ev->xconfigurerequest.window,
			     ev->type, &ev2))
    {
      if (mask != ev2.xconfigurerequest.value_mask)
	{
	  HandleConfigureRequest(ev);
	  HandleConfigureRequest(&ev2);
	}
      else
	{
	  while (mask == ev2.xconfigurerequest.value_mask)
	    {
	      if (XCheckTypedWindowEvent(disp, ev->xconfigurerequest.window,
					 ev->type, &ev2))
		{
		  if (mask != ev2.xconfigurerequest.value_mask)
		    {
		      HandleConfigureRequest(ev);
		      HandleConfigureRequest(&ev2);
		      break;
		    }
		}
	      else
		{
		  HandleConfigureRequest(&ev2);
		  break;
		}
	    }
	}
    }
  else
    HandleConfigureRequest(ev);
  EDBUG_RETURN_;
}

void
HGravityNotify(XEvent * ev)
{
  EDBUG(7, "HGravityNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HResizeRequest(XEvent * ev)
{
  EDBUG(7, "HResizeRequest");
  HandleResizeRequest(ev);
  EDBUG_RETURN_;
}

void
HCirculateNotify(XEvent * ev)
{
  EDBUG(7, "HCirculateNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HCirculateRequest(XEvent * ev)
{
  EDBUG(7, "HCirculateRequest");
  HandleCirculate(ev);
  EDBUG_RETURN_;
}

void
HPropertyNotify(XEvent * ev)
{
  EDBUG(7, "HPropertyNotify");
  HandleProperty(ev);
  DesktopAccounting();
  EDBUG_RETURN_;
}

void
HSelectionClear(XEvent * ev)
{
  EDBUG(7, "HSelectionClear");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HSelectionRequest(XEvent * ev)
{
  EDBUG(7, "HSelectionRequest");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HSelectionNotify(XEvent * ev)
{
  EDBUG(7, "HSelectionNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HColormapNotify(XEvent * ev)
{
  EDBUG(7, "HColormapNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
HClientMessage(XEvent * ev)
{
  EDBUG(7, "HClientMessage");
  HandleClientMessage(ev);
  EDBUG_RETURN_;
}

void
HMappingNotify(XEvent * ev)
{
  EDBUG(7, "HMappingNotify");
  ev = NULL;
  EDBUG_RETURN_;
}

void
DefaultFunc(XEvent * ev)
{
  EDBUG(7, "DefaultFunc");
  ev = NULL;
  EDBUG_RETURN_;
}
