#include "E.h"

static char         focus_dir = 0;

void                ReverseTimeout(int val, void *data);
void                AutoraiseTimeout(int val, void *data);

void
ReverseTimeout(int val, void *data)
{
  FlipFocusList();
  val = 0;
  data = NULL;
}

/* Mostly stolen from the temporary 'ToolTipTimeout' */
void
AutoraiseTimeout(int val, void *data)
{
  EWin               *found_ewin;

  EDBUG(5, "AutoraiseTimeout");

  found_ewin = FindEwinByChildren(val);
  RaiseEwin(found_ewin);

  EDBUG_RETURN_;
  data = NULL;
  val = 0;
}

void
FlipFocusList(void)
{
  EDBUG(5, "FlipFocusList");
  if (focus_dir)
    focus_dir = 0;
  else
    focus_dir = 1;
  EDBUG_RETURN_;
}

void
GetNextFocusEwin(void)
{
  EWin              **lst0, **lst, *ewin;
  int                 i, num0, num;
  Window              win;

  EDBUG(5, "GetNextFocusEwin");
  RemoveTimerEvent("REVERSE_FOCUS_TIMEOUT");
  DoIn("REVERSE_FOCUS_TIMEOUT", 1.0, ReverseTimeout, 0, NULL);
  lst0 = (EWin **) ListItemType(&num0, LIST_TYPE_EWIN);
  num = 0;
  lst = NULL;
  if (lst0)
    {
      for (i = 0; i < num0; i++)
	{
	  ewin = lst0[i];
	  if (((ewin->sticky) || (ewin->desktop == desks.current)) &&
	      (!(ewin->skipfocus)) && (!(ewin->internal)))
	    {
	      num++;
	      lst = Erealloc(lst, sizeof(EWin *) * num);
	      lst[num - 1] = lst0[i];
	    }
	}
      Efree(lst0);
    }
  ewin = NULL;
  if (lst)
    {
      for (i = 0; i < num; i++)
	{
	  if (mode.focuswin == lst[i])
	    {
	      if (focus_dir)
		{
		  if (i == 0)
		    ewin = lst[num - 1];
		  else
		    ewin = lst[i - 1];
		  Efree(lst);
		  RaiseEwin(ewin);
/*                     XWarpPointer(disp, None, ewin->win, 0, 0, 0, 0,
 * ewin->w / 2, ewin->h / 2); */
		  win = ewin->client.win;
		  XSync(disp, False);
		  CheckEvent();
		  if (FindItem(NULL, win, LIST_FINDBY_ID, LIST_TYPE_EWIN))
		    FocusToEWin(ewin);
		  EDBUG_RETURN_;
		}
	      else
		{
		  if (i == num - 1)
		    ewin = lst[0];
		  else
		    ewin = lst[i + 1];
		  Efree(lst);
		  RaiseEwin(ewin);
/*                     XWarpPointer(disp, None, ewin->win, 0, 0, 0, 0,
 * ewin->w / 2, ewin->h / 2); */
		  win = ewin->client.win;
		  XSync(disp, False);
		  CheckEvent();
		  if (FindItem(NULL, win, LIST_FINDBY_ID, LIST_TYPE_EWIN))
		    FocusToEWin(ewin);
		  EDBUG_RETURN_;
		}
	    }
	}
      ewin = lst[0];
      Efree(lst);
      RaiseEwin(ewin);
/*      XWarpPointer(disp, None, ewin->win, 0, 0, 0, 0,
 * ewin->w / 2, ewin->h / 2); */
      FocusToEWin(ewin);
    }
  EDBUG_RETURN_;
}

void
GetPrevFocusEwin(void)
{
  EWin              **lst0, **lst, *ewin;
  int                 i, num0, num;
  Window              win;

  EDBUG(5, "GetPrevFocusEwin");
  RemoveTimerEvent("REVERSE_FOCUS_TIMEOUT");
  DoIn("REVERSE_FOCUS_TIMEOUT", 1.0, ReverseTimeout, 0, NULL);
  lst0 = (EWin **) ListItemType(&num0, LIST_TYPE_EWIN);
  num = 0;
  lst = NULL;
  if (lst0)
    {
      for (i = 0; i < num0; i++)
	{
	  ewin = lst0[i];
	  if (((ewin->sticky) || (ewin->desktop == desks.current)) &&
	      (!(ewin->skipfocus)) && (!(ewin->internal)))
	    {
	      num++;
	      lst = Erealloc(lst, sizeof(EWin *) * num);
	      lst[num - 1] = lst0[i];
	    }
	}
      Efree(lst0);
    }
  ewin = NULL;
  if (lst)
    {
      for (i = 0; i < num; i++)
	{
	  if (mode.focuswin == lst[i])
	    {
	      if (!(focus_dir))
		{
		  if (i == 0)
		    ewin = lst[num - 1];
		  else
		    ewin = lst[i - 1];
		  Efree(lst);
		  RaiseEwin(ewin);
/*                     XWarpPointer(disp, None, ewin->win, 0, 0, 0, 0,
 * ewin->w / 2, ewin->h / 2); */
		  win = ewin->client.win;
		  XSync(disp, False);
		  CheckEvent();
		  if (FindItem(NULL, win, LIST_FINDBY_ID, LIST_TYPE_EWIN))
		    FocusToEWin(ewin);
		  EDBUG_RETURN_;
		}
	      else
		{
		  if (i == num - 1)
		    ewin = lst[0];
		  else
		    ewin = lst[i + 1];
		  Efree(lst);
		  RaiseEwin(ewin);
/*                     XWarpPointer(disp, None, ewin->win, 0, 0, 0, 0,
 * ewin->w / 2, ewin->h / 2); */
		  win = ewin->client.win;
		  XSync(disp, False);
		  CheckEvent();
		  if (FindItem(NULL, win, LIST_FINDBY_ID, LIST_TYPE_EWIN))
		    FocusToEWin(ewin);
		  EDBUG_RETURN_;
		}
	    }
	}
      ewin = lst[0];
      Efree(lst);
      RaiseEwin(ewin);
/*      XWarpPointer(disp, None, ewin->win, 0, 0, 0, 0,
 * ewin->w / 2, ewin->h / 2); */
      FocusToEWin(ewin);
    }
  EDBUG_RETURN_;
}

void
FixFocus(void)
{
  EWin              **lst, *ewin;
  int                 i, num;

  EDBUG(5, "FixFocus");
  num = 0;
  lst = (EWin **) ListItemType(&num, LIST_TYPE_EWIN);
  if (lst)
    {
      for (i = 0; i < num; i++)
	{
	  ewin = lst[i];
	  if (mode.focusmode == FOCUS_CLICK)
	    {
	      if (!(ewin->active))
		XGrabButton(disp, AnyButton, 0, ewin->win_container, False,
			    ButtonPressMask,
			    GrabModeSync, GrabModeAsync, None, None);
	    }
	  else
	    XUngrabButton(disp, AnyButton, 0, ewin->win_container);
	}
      Efree(lst);
    }

}

void
FocusToEWin(EWin * ewin)
{
  EDBUG(4, "FocusToEWin");

  if (mode.slideout)
    EDBUG_RETURN_;
  if (mode.focuswin)
    {
      RemoveTimerEvent("AUTORAISE_TIMEOUT");

      mode.focuswin->active = 0;

      /*
       * losing the focus may cause the titlebar to be resized
       */
      CalcEwinSizes(mode.focuswin);
      DrawEwin(mode.focuswin);
      if (mode.focusmode == FOCUS_CLICK)
	XGrabButton(disp, AnyButton, 0, mode.focuswin->win_container, False,
		    ButtonPressMask,
		    GrabModeSync, GrabModeAsync, None, None);
    }
  mode.focuswin = ewin;
  if (!ewin)
    mode.realfocuswin = NULL;
  else if (!ewin->internal)
    mode.realfocuswin = ewin;
  if (mode.focuswin)
    {
      mode.focuswin->active = 1;
      /*
       * gaining the focus may cause the titlebar to be resized
       */
      CalcEwinSizes(mode.focuswin);
      DrawEwin(mode.focuswin);
      if (mode.focusmode == FOCUS_CLICK)
	XUngrabButton(disp, AnyButton, 0, mode.focuswin->win_container);

      if (mode.autoraise)
	DoIn("AUTORAISE_TIMEOUT", mode.autoraisetime, AutoraiseTimeout, mode.focuswin->win_container, NULL);
    }
  ICCCM_Focus(mode.focuswin);
  EDBUG_RETURN_;
}
