#include "E.h"

static MenuStyle   *task_menu_style = NULL;
static MenuStyle   *desk_menu_style = NULL;

char               *FileExtension(char *file);

void                addmenu(void);

/* FIXME: this addmenu(); is temporary - needs to be removed later for real */
/* root menus */
void
addmenu(void)
{
  static Menu        *m = NULL;

  XUngrabPointer(disp, CurrentTime);
  m = FindItem("ROOT_2", 0, LIST_FINDBY_NAME, LIST_TYPE_MENU);
  if (m)
    {
      mode.cur_menu_mode = 1;
      if (!FindEwinByMenu(m))
	ShowMenu(m, 0);
      mode.cur_menu[0] = m;
      mode.cur_menu_depth = 1;
      ShowMenuMasker(m);
    }
  else
    {
      mode.cur_menu[0] = NULL;
      mode.cur_menu_depth = 0;
      HideMenuMasker();
    }

/*  ShowDeskMenu(); */
}

char               *
FileExtension(char *file)
{
  char               *p = strrchr(file, '.');

  EDBUG(5, "FileExtension");
  if (p == NULL)
    {
      EDBUG_RETURN("");
    }
  else
    {
      EDBUG_RETURN(p + 1);
    }
}

void
ShowTaskMenu(void)
{
  EDBUG(5, "ShowTaskMenu");
  EDBUG_RETURN_;
}

/* FIXME: need to use standard named menustyle */
void
ShowAllTaskMenu(void)
{
  static MenuStyle   *ms = NULL;
  static Menu        *m = NULL;

  EDBUG(5, "ShowAllTaskMenu");
  XUngrabPointer(disp, CurrentTime);
  if (!task_menu_style)
    {
      ms = FindItem("TASK_MENU", 0, LIST_FINDBY_NAME, LIST_TYPE_MENU_STYLE);
      if (!ms)
	ms = FindItem("DEFAULT", 0, LIST_FINDBY_NAME, LIST_TYPE_MENU_STYLE);
      if (!ms)
	EDBUG_RETURN_;
    }
  task_menu_style = ms;
  mode.cur_menu_mode = 1;
  m = NULL;
  m = RefreshAllTaskMenu(all_task_menu);
  all_task_menu = m;
  if (m)
    {
      if (!FindEwinByMenu(m))
	ShowMenu(m, 0);
      mode.cur_menu[0] = m;
      mode.cur_menu_depth = 1;
      ShowMenuMasker(m);
    }
  else
    {
      mode.cur_menu[0] = NULL;
      mode.cur_menu_depth = 0;
      HideMenuMasker();
    }
  EDBUG_RETURN_;
}

/* FIXME: need to use standard named menustyle */
void
ShowDeskMenu(void)
{
  static MenuStyle   *ms = NULL;
  static Menu        *m = NULL;

  EDBUG(5, "ShowDeskMenu");
  XUngrabPointer(disp, CurrentTime);
  if (!desk_menu_style)
    {
      ms = FindItem("DESK_MENU", 0, LIST_FINDBY_NAME, LIST_TYPE_MENU_STYLE);
      if (!ms)
	ms = FindItem("DEFAULT", 0, LIST_FINDBY_NAME, LIST_TYPE_MENU_STYLE);
      if (!ms)
	EDBUG_RETURN_;
    }
  desk_menu_style = ms;
  mode.cur_menu_mode = 1;
  m = NULL;
  m = RefreshDeskMenu(desk_menu);
  desk_menu = m;
  if (m)
    {
      if (!FindEwinByMenu(m))
	ShowMenu(m, 0);
      mode.cur_menu[0] = m;
      mode.cur_menu_depth = 1;
      ShowMenuMasker(m);
    }
  else
    {
      mode.cur_menu[0] = NULL;
      mode.cur_menu_depth = 0;
      HideMenuMasker();
    }
  EDBUG_RETURN_;
}

Menu               *
RefreshTaskMenu(int desk)
{
  char                was = 0;
  int                 lx = 0, ly = 0;
  EWin               *ewin;

  EDBUG(5, "RefreshTaskMenu");
  if (task_menu[desk])
    {
      ewin = FindEwinByMenu(task_menu[desk]);
      if ((task_menu[desk]->win) && (ewin))
	{
	  lx = ewin->x;
	  ly = ewin->y;
	  was = 1;
	}
      DestroyMenu(task_menu[desk]);
    }
  task_menu[desk] = NULL;
  if (!task_menu_style)
    {
      EDBUG_RETURN(NULL);
    }
  task_menu[desk] = CreateMenuFromDesktopEWins("MENU", task_menu_style, desk);
  if ((was) && (task_menu[desk]))
    {
      ShowMenu(task_menu[desk], 1);
      ewin = FindEwinByMenu(task_menu[desk]);
      if (ewin)
	{
	  MoveEwin(ewin, lx, ly);
	  ShowEwin(ewin);
	}
      mode.cur_menu[0] = task_menu[desk];
      mode.cur_menu_depth = 1;
      ShowMenuMasker(task_menu[desk]);
    }
  EDBUG_RETURN(task_menu[desk]);
}

Menu               *
RefreshAllTaskMenu(Menu * m)
{
  char                was = 0;
  int                 lx = 0, ly = 0;
  EWin               *ewin;

  EDBUG(5, "RefreshAllTaskMenu");
  if (m)
    {
      ewin = FindEwinByMenu(m);
      if ((m->win) && (ewin))
	{
	  lx = ewin->x;
	  ly = ewin->y;
	  was = 1;
	}
      DestroyMenu(m);
    }
  m = NULL;
  if (!task_menu_style)
    {
      EDBUG_RETURN(NULL);
    }
  m = CreateMenuFromAllEWins("MENU", task_menu_style);
  if ((was) && (m))
    {
      ShowMenu(m, 1);
      ewin = FindEwinByMenu(m);
      if (ewin)
	{
	  MoveEwin(ewin, lx, ly);
	  ShowEwin(ewin);
	}
      mode.cur_menu[0] = m;
      mode.cur_menu_depth = 1;
      ShowMenuMasker(m);
    }
  EDBUG_RETURN(m);
}

Menu               *
RefreshDeskMenu(Menu * m)
{
  char                was = 0;
  int                 lx = 0, ly = 0;
  EWin               *ewin;

  EDBUG(5, "RefreshDeskMenu");
  if (m)
    {
      ewin = FindEwinByMenu(m);
      if ((m->win) && (ewin))
	{
	  lx = ewin->x;
	  ly = ewin->y;
	  was = 1;
	}
      DestroyMenu(m);
    }
  m = NULL;
  if (!desk_menu_style)
    {
      EDBUG_RETURN(NULL);
    }
  m = CreateMenuFromDesktops("MENU", desk_menu_style);
  if ((was) && (m))
    {
      ShowMenu(m, 1);
      ewin = FindEwinByMenu(m);
      if (ewin)
	{
	  MoveEwin(ewin, lx, ly);
	  ShowEwin(ewin);
	}
      mode.cur_menu[0] = m;
      mode.cur_menu_depth = 1;
      ShowMenuMasker(m);
    }
  EDBUG_RETURN(m);
}

void
HideMenu(Menu * m)
{
  EWin               *ewin;
  XEvent              ev;

  EDBUG(5, "HideMenu");
  if (m->win)
    XUnmapWindow(disp, m->win);
  ewin = FindEwinByMenu(m);
  if (ewin)
    {
      HideEwin(ewin);
      ev.xunmap.window = m->win;
      HandleUnmap(&ev);
    }
  if (m->sel_item)
    {
      m->sel_item->state = STATE_NORMAL;
      DrawMenuItem(m, m->sel_item, 1);
      m->sel_item = NULL;
    }
  m->stuck = 0;
  EDBUG_RETURN_;
}

void
ShowMenu(Menu * m, char noshow)
{
  EWin               *ewin;
  int                 x, y;
  unsigned int        w, h;

  EDBUG(5, "ShowMenu");
  if (m->num <= 0)
    EDBUG_RETURN_;
  if (m->stuck)
    EDBUG_RETURN_;
  if (!m->win)
    RealizeMenu(m);
  ewin = FindEwinByMenu(m);
  if (ewin)
    {
      RaiseEwin(ewin);
      EDBUG_RETURN_;
    }
  GetWinXY(m->items[0]->win, &x, &y);
  GetWinWH(m->items[0]->win, &w, &h);
  XMoveWindow(disp, m->win, mode.x - x - (w / 2), mode.y - y - (h / 2));
  ewin = AddInternalToFamily(m->win, 1, m->style->border_name);
  if (ewin)
    {
      if (ewin->desktop != 0)
	MoveEwin(ewin, ewin->x - desks.desk[ewin->desktop].x,
		 ewin->y - desks.desk[ewin->desktop].y);
/*      
 * if (ewin->x + ewin->w > root.w)
 * MoveEwin(ewin, root.w - ewin->w, ewin->y);
 * if (ewin->y + ewin->h > root.h)
 * MoveEwin(ewin, ewin->x, root.h - ewin->h);
 * if (ewin->x < 0)
 * MoveEwin(ewin, 0, ewin->y);
 * if (ewin->y < 0)
 * MoveEwin(ewin, ewin->x, 0);
 */
      if (mode.menuslide)
	InstantShadeEwin(ewin);
      if (!noshow)
	{
	  ShowEwin(ewin);
	  if (mode.menuslide)
	    UnShadeEwin(ewin);
	}
      ewin->menu = m;
    }
  m->stuck = 0;
  if (!FindMenu(m->win))
    AddItem(m, m->name, m->win, LIST_TYPE_MENU);
  EDBUG_RETURN_;
}

MenuStyle          *
CreateMenuStyle(void)
{
  MenuStyle          *ms;

  EDBUG(5, "CreateMenuStyle");
  ms = Emalloc(sizeof(MenuStyle));

  ms->name = NULL;
  ms->tclass = NULL;
  ms->bg_iclass = NULL;
  ms->item_iclass = NULL;
  ms->sub_iclass = NULL;
  ms->use_item_bg = 0;
  ms->iconpos = ICON_LEFT;
  ms->maxx = 0;
  ms->maxy = 0;
  ms->border_name = NULL;
  EDBUG_RETURN(ms);
}

MenuItem           *
CreateMenuItem(char *text, ImageClass * iclass, ActionClass * aclass,
	       Menu * child)
{
  MenuItem           *mi;

  EDBUG(5, "CreateMenuItem");
  mi = Emalloc(sizeof(MenuItem));

  mi->icon_iclass = iclass;
  mi->text = duplicate(text);
  mi->aclass = aclass;
  mi->child = child;
  mi->state = STATE_NORMAL;
  mi->win = 0;
  mi->pmap[0] = 0;
  mi->pmap[1] = 0;
  mi->pmap[2] = 0;
  mi->mask[0] = 0;
  mi->mask[1] = 0;
  mi->mask[2] = 0;
  mi->icon_win = 0;
  mi->icon_w = 0;
  mi->icon_h = 0;
  mi->text_w = 0;
  mi->text_h = 0;
  mi->text_x = 0;
  mi->text_y = 0;
  EDBUG_RETURN(mi);
}

Menu               *
CreateMenu(void)
{
  Menu               *m;

  EDBUG(5, "CreateMenu");
  m = Emalloc(sizeof(Menu));
  m->name = NULL;
  m->style = NULL;
  m->num = 0;
  m->items = NULL;
  m->win = 0;
  m->pmap = 0;
  m->mask = 0;
  m->stuck = 0;
  m->parent = NULL;
  m->sel_item = NULL;
  EDBUG_RETURN(m);
}

void
DestroyMenu(Menu * m)
{
  int                 i, j;

  EDBUG(5, "DestroyMenu");
  if (!m)
    EDBUG_RETURN_;
  if (m->win)
    RemoveItem(NULL, m->win, LIST_FINDBY_ID, LIST_TYPE_MENU);
  HideMenu(m);
  if (m->name)
    Efree(m->name);
  for (i = 0; i < m->num; i++)
    {
      if (m->items[i])
	{
	  if (m->items[i]->child)
	    DestroyMenu(m->items[i]->child);
	  if (m->items[i]->text)
	    Efree(m->items[i]->text);
	  if (m->items[i]->aclass)
	    RemoveActionClass(m->items[i]->aclass);
	  for (j = 0; j < 3; j++)
	    {
	      if (m->items[i]->pmap[j])
		Imlib_free_pixmap(id, m->items[i]->pmap[j]);
	      if (m->items[i]->mask[j])
		Imlib_free_pixmap(id, m->items[i]->mask[j]);
	    }
	  if (m->items[i])
	    Efree(m->items[i]);
	}
    }
  if (m->items)
    Efree(m->items);
  if (m->win)
    XDestroyWindow(disp, m->win);
  Efree(m);
  EDBUG_RETURN_;
}

void
AddItemToMenu(Menu * menu, MenuItem * item)
{
  EDBUG(5, "CreateMenu");
  menu->num++;
  menu->items = Erealloc(menu->items, sizeof(MenuItem *) * menu->num);
  menu->items[menu->num - 1] = item;
  EDBUG_RETURN_;
}

void
RealizeMenu(Menu * m)
{
  int                 i, maxh, maxw, maxx1, maxx2, w, h, x, y, r, mmw, mmh;
  unsigned int        iw, ih;
  ImlibImage         *im;
  XSetWindowAttributes att;
  char                pq;

  EDBUG(5, "RealizeMenu");
  m->win = ECreateWindow(root.win, 0, 0, 1, 1, 0);
  maxh = 0;
  maxx1 = 0;
  maxx2 = 0;
  att.event_mask = PointerMotionMask;
  XChangeWindowAttributes(disp, m->win, CWEventMask, &att);
  att.event_mask = ButtonPressMask | ButtonReleaseMask | EnterWindowMask |
    LeaveWindowMask | PointerMotionMask;
  for (i = 0; i < m->num; i++)
    {
      m->items[i]->win = ECreateWindow(m->win, 0, 0, 1, 1, 0);
      XChangeWindowAttributes(disp, m->items[i]->win, CWEventMask, &att);
      XMapWindow(disp, m->items[i]->win);
      if ((m->style->tclass) && (m->items[i]->text))
	{
	  TextSize(m->style->tclass, 0, 0, 0, m->items[i]->text, &w, &h, 17);
	  if (h > maxh)
	    maxh = h;
	  if (w > maxx1)
	    maxx1 = w;
	  m->items[i]->text_w = w;
	  m->items[i]->text_h = h;
	}
      if (m->items[i]->icon_iclass)
	{
	  im = ELoadImage(m->items[i]->icon_iclass->norm.normal->im_file);
	  if (im)
	    {
	      m->items[i]->icon_win = ECreateWindow(m->items[i]->win, 0, 0,
						    im->rgb_width,
						    im->rgb_height, 0);
	      XMapWindow(disp, m->items[i]->icon_win);
	      XChangeWindowAttributes(disp, m->items[i]->icon_win, CWEventMask, &att);
	      m->items[i]->icon_w = im->rgb_width;
	      m->items[i]->icon_h = im->rgb_height;
	      if (im->rgb_height > maxh)
		maxh = im->rgb_height;
	      if (im->rgb_width > maxx2)
		maxx2 = im->rgb_width;
	      Imlib_destroy_image(id, im);
	    }
	  else
	    {
	      printf("error finding %s\n", m->items[i]->icon_iclass->norm.normal->im_file);
	      m->items[i]->icon_iclass = NULL;
	    }
	}
    }
  if (m->style->item_iclass->padding.top > m->style->sub_iclass->padding.top)
    maxh += m->style->item_iclass->padding.top;
  else
    maxh += m->style->sub_iclass->padding.top;
  if (m->style->item_iclass->padding.bottom > m->style->sub_iclass->padding.bottom)
    maxh += m->style->item_iclass->padding.bottom;
  else
    maxh += m->style->sub_iclass->padding.bottom;
  maxw = maxx1 + maxx2;
  if (m->style->item_iclass->padding.left > m->style->sub_iclass->padding.left)
    maxw += m->style->item_iclass->padding.left;
  else
    maxw += m->style->sub_iclass->padding.left;
  if (m->style->item_iclass->padding.right > m->style->sub_iclass->padding.right)
    maxw += m->style->item_iclass->padding.right;
  else
    maxw += m->style->sub_iclass->padding.right;

  x = 0;
  y = 0;
  if ((m->style->bg_iclass) && (!m->style->use_item_bg))
    {
      x = m->style->bg_iclass->padding.left;
      y = m->style->bg_iclass->padding.top;
    }
  r = 0;
  mmw = 0;
  mmh = 0;
  pq = queue_up;
  queue_up = 0;
  for (i = 0; i < m->num; i++)
    {
      XMoveResizeWindow(disp, m->items[i]->win, x, y, maxw, maxh);
      if (m->style->iconpos == ICON_LEFT)
	{
	  m->items[i]->text_x = m->style->item_iclass->padding.left + maxx2 +
	    ((maxx1 - m->items[i]->text_w) / 2);
	  m->items[i]->text_y = (maxh - m->items[i]->text_h) / 2;
	  if (m->items[i]->icon_win)
	    XMoveWindow(disp, m->items[i]->icon_win,
			m->style->item_iclass->padding.left +
			((maxx2 - m->items[i]->icon_w) / 2),
			((maxh - m->items[i]->icon_h) / 2));
	}
      else
	{
	  m->items[i]->text_x = m->style->item_iclass->padding.left;
	  m->items[i]->text_y = (maxh - m->items[i]->text_h) / 2;
	  if (m->items[i]->icon_win)
	    XMoveWindow(disp, m->items[i]->icon_win, maxw -
			m->style->item_iclass->padding.right - maxx2 +
			((maxx2 - w) / 2), ((maxh - h) / 2));
	}
      if (m->items[i]->icon_iclass)
	{
	  iw = 0;
	  ih = 0;
	  GetWinWH(m->items[i]->icon_win, &iw, &ih);
	  IclassApply(m->items[i]->icon_iclass, m->items[i]->icon_win, iw, ih,
		      0, 0, STATE_NORMAL, 0);
	}
      if (x + maxw > mmw)
	mmw = x + maxw;
      if (y + maxh > mmh)
	mmh = y + maxh;
      if ((m->style->maxx) || (m->style->maxy))
	{
	  if (m->style->maxy)
	    {
	      y += maxh;
	      r++;
	      if (r >= m->style->maxy)
		{
		  r = 0;
		  x += maxw;
		  y = 0;
		}
	    }
	  else
	    {
	      x += maxw;
	      r++;
	      if (r >= m->style->maxx)
		{
		  r = 0;
		  y += maxh;
		  x = 0;
		}
	    }
	}
      else
	y += maxh;
    }
  if ((m->style->bg_iclass) && (!m->style->use_item_bg))
    {
      mmw += m->style->bg_iclass->padding.right;
      mmh += m->style->bg_iclass->padding.bottom;
    }
  XResizeWindow(disp, m->win, mmw, mmh);
  if (!m->style->use_item_bg)
    {
      IclassApplyCopy(m->style->bg_iclass, m->win, mmw, mmh, 0, 0,
		      STATE_NORMAL, &(m->pmap), &(m->mask));
      XSetWindowBackgroundPixmap(disp, m->win, m->pmap);
      XShapeCombineMask(disp, m->win, ShapeBounding,
			0, 0, m->mask, ShapeSet);
      for (i = 0; i < m->num; i++)
	DrawMenuItem(m, m->items[i], 0);
    }
  else
    {
      for (i = 0; i < m->num; i++)
	DrawMenuItem(m, m->items[i], 0);
      PropagateShapes(m->win);
    }
  queue_up = pq;
  EDBUG_RETURN_;
}

void
DrawMenuItem(Menu * m, MenuItem * mi, char shape)
{
  GC                  gc;
  XGCValues           gcv;
  unsigned int        w, h;
  int                 x, y;
  char                pq;
  Pixmap              pmap, mask;

  EDBUG(5, "DrawMenuItem");
  pq = queue_up;
  queue_up = 0;
  if (!mi->pmap[mi->state])
    {
      if (mi->text)
	{
	  GetWinWH(mi->win, &w, &h);
	  GetWinXY(mi->win, &x, &y);
	  if (!m->style->use_item_bg)
	    {
	      mi->pmap[mi->state] = XCreatePixmap(disp, mi->win, w, h, id->x.depth);
	      gc = XCreateGC(disp, m->pmap, 0, &gcv);
	      XCopyArea(disp, m->pmap, mi->pmap[mi->state], gc, x, y, w, h, 0, 0);
	      mi->mask[mi->state] = None;
	      if ((mi->state != STATE_NORMAL) || (mi->child))
		{
		  pmap = 0;
		  mask = 0;
		  if (mi->child)
		    IclassApplyCopy(m->style->sub_iclass, mi->win, w, h, 0, 0, mi->state,
				    &pmap, &mask);
		  else
		    IclassApplyCopy(m->style->item_iclass, mi->win, w, h, 0, 0, mi->state,
				    &pmap, &mask);
		  if (mask)
		    {
		      XSetClipMask(disp, gc, mask);
		      XSetClipOrigin(disp, gc, 0, 0);
		    }
		  XCopyArea(disp, pmap, mi->pmap[mi->state], gc, 0, 0, w, h, 0, 0);
		  Imlib_free_pixmap(id, pmap);
		}
	      XFreeGC(disp, gc);
	    }
	  else
	    {
	      if (mi->child)
		IclassApplyCopy(m->style->sub_iclass, mi->win, w, h, 0, 0, mi->state,
			      &(mi->pmap[mi->state]), &(mi->mask[mi->state]));
	      else
		IclassApplyCopy(m->style->item_iclass, mi->win, w, h, 0, 0, mi->state,
			      &(mi->pmap[mi->state]), &(mi->mask[mi->state]));
	    }
	}
    }
  if ((m->style->tclass) && (mi->text))
    {
      TextDraw(m->style->tclass, mi->pmap[mi->state], 0, 0, mi->state,
	       mi->text, mi->text_x, mi->text_y, mi->text_w, mi->text_h, 17,
	       m->style->tclass->justification);
    }
  if (mi->text)
    {
      XSetWindowBackgroundPixmap(disp, mi->win, mi->pmap[mi->state]);
      XShapeCombineMask(disp, mi->win, ShapeBounding,
			0, 0, mi->mask[mi->state], ShapeSet);
      XClearWindow(disp, mi->win);
    }
  else
    {
      GetWinWH(mi->win, &w, &h);
      GetWinXY(mi->win, &x, &y);
      if (!m->style->use_item_bg)
	{
	  if ((mi->state != STATE_NORMAL) || (mi->child))
	    IclassApply(m->style->item_iclass, mi->win, w, h, 0, 0, mi->state, 0);
	  else
	    {
	      XSetWindowBackgroundPixmap(disp, mi->win, ParentRelative);
	      XShapeCombineMask(disp, mi->win, ShapeBounding,
				0, 0, None, ShapeSet);
	      XClearWindow(disp, mi->win);
	    }
	}
      else
	{
	  if (mi->child)
	    IclassApply(m->style->sub_iclass, mi->win, w, h, 0, 0, mi->state, 0);
	  else
	    IclassApply(m->style->item_iclass, mi->win, w, h, 0, 0, mi->state, 0);
	}
    }
  if ((shape) && (m->style->use_item_bg))
    PropagateShapes(m->win);
  queue_up = pq;
  EDBUG_RETURN_;
}

Menu               *
CreateMenuFromDirectory(char *name, MenuStyle * ms, char *dir)
{
  Progressbar        *p = NULL;
  Menu               *m, *mm;
  int                 i, num;
  char              **list, s[4096], ss[4096], *ext;
  MenuItem           *mi;
  ActionClass        *ac = NULL;
  Action             *a;
  const char         *chmap =
  "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-_";

  EDBUG(5, "CreateMenuFromDirectory");
  m = CreateMenu();
  m->name = duplicate(name);
  m->style = ms;
  list = ls(dir, &num);
  Esnprintf(s, sizeof(s), "Scanning %s", dir);
  if (!init_win_ext)
    p = CreateProgressbar(s, 600, 16);
  if (p)
    ShowProgressbar(p);
  for (i = 0; i < num; i++)
    {
      if (p)
	SetProgressbar(p, (i * 100) / (num - 1));
      if ((strcmp(list[i], ".")) && (strcmp(list[i], "..")))
	{
	  Esnprintf(ss, sizeof(ss), "%s/%s", dir, list[i]);
	  ext = FileExtension(ss);
	  if (isdir(ss))
	    {
	      if ((strcmp(".", list[i])) && (strcmp("..", list[i])))
		{
		  Esnprintf(s, sizeof(s), "%s/%s:%s", dir, list[i], name);
		  Esnprintf(ss, sizeof(ss), "%s/%s", dir, list[i]);
		  mm = CreateMenuFromDirectory(s, ms, ss);
		  mm->parent = m;
		  AddItem(mm, mm->name, mm->win, LIST_TYPE_MENU);
		  mi = CreateMenuItem(list[i], NULL, NULL, mm);
		  AddItemToMenu(m, mi);
		}
	    }
	  else if (canexec(ss))
	    {
	      ac = CreateAclass(ss);
	      a = CreateAction(EVENT_MOUSE_UP, 0, 0, 0, 0, 0, NULL);
	      AddAction(ac, a);
	      AddToAction(a, ACTION_EXEC, duplicate(ss));
	      mi = CreateMenuItem(list[i], NULL, ac, NULL);
	      AddItemToMenu(m, mi);
	    }
	  else if ((!strcmp(ext, "jpg")) || (!strcmp(ext, "JPG")) ||
		   (!strcmp(ext, "jpeg")) || (!strcmp(ext, "Jpeg")) ||
		   (!strcmp(ext, "JPEG")) || (!strcmp(ext, "Jpg")) ||
		   (!strcmp(ext, "gif")) || (!strcmp(ext, "Gif")) ||
		   (!strcmp(ext, "GIF")) || (!strcmp(ext, "png")) ||
		   (!strcmp(ext, "Png")) || (!strcmp(ext, "PNG")) ||
		   (!strcmp(ext, "tif")) || (!strcmp(ext, "Tif")) ||
		   (!strcmp(ext, "TIFF")) || (!strcmp(ext, "tiff")) ||
		   (!strcmp(ext, "Tiff")) || (!strcmp(ext, "TIFF")) ||
		   (!strcmp(ext, "xpm")) || (!strcmp(ext, "Xpm")) ||
		   (!strcmp(ext, "XPM")) || (!strcmp(ext, "ppm")) ||
		   (!strcmp(ext, "PPM")) || (!strcmp(ext, "pgm")) ||
		   (!strcmp(ext, "PGM")) || (!strcmp(ext, "pnm")) ||
		   (!strcmp(ext, "PNM")) || (!strcmp(ext, "bmp")) ||
		   (!strcmp(ext, "Bmp")) || (!strcmp(ext, "BMP")))
	    {
	      Background         *bg;
	      char                ok = 1;
	      char               *home;
	      char                s2[4096], s3[512];
	      int                 aa, bb, cc;

	      aa = fileinode(ss);
	      bb = filedev(ss);
	      cc = moddate(ss);
	      Esnprintf(s3, sizeof(s3), ".%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",
			chmap[(aa >> 0) & 0x3f],
			chmap[(aa >> 6) & 0x3f],
			chmap[(aa >> 12) & 0x3f],
			chmap[(aa >> 18) & 0x3f],
			chmap[(aa >> 24) & 0x3f],
			chmap[(aa >> 28) & 0x3f],
			chmap[(bb >> 0) & 0x3f],
			chmap[(bb >> 6) & 0x3f],
			chmap[(bb >> 12) & 0x3f],
			chmap[(bb >> 18) & 0x3f],
			chmap[(bb >> 24) & 0x3f],
			chmap[(bb >> 28) & 0x3f],
			chmap[(cc >> 0) & 0x3f],
			chmap[(cc >> 6) & 0x3f],
			chmap[(cc >> 12) & 0x3f],
			chmap[(cc >> 18) & 0x3f],
			chmap[(cc >> 24) & 0x3f],
			chmap[(cc >> 28) & 0x3f]);
	      bg = (Background *) FindItem(s3, 0, LIST_FINDBY_NAME, LIST_TYPE_BACKGROUND);
	      if (!bg)
		{
		  ImlibImage         *im;

		  im = Imlib_load_image(id, ss);
		  if (im)
		    {
		      ImlibImage         *im2;
		      ImlibColor          icl;
		      char                tile = 1, keep_asp = 0;
		      int                 width, height, scalex = 0, scaley = 0;
		      int                 scr_asp, im_asp, w2, h2;
		      int                 maxw = 48, maxh = 48;

		      home = homedir(getuid());
		      Esnprintf(s2, sizeof(s2), "%s/.enlightenment/%s", home, s3);
		      if (home)
			Efree(home);
		      width = im->rgb_width;
		      height = im->rgb_height;
		      h2 = maxh;
		      w2 = (im->rgb_width * h2) / im->rgb_height;
		      if (w2 > maxw)
			{
			  w2 = maxw;
			  h2 = (im->rgb_height * w2) / im->rgb_width;
			}
		      im2 = Imlib_clone_scaled_image(id, im, w2, h2);
		      Imlib_save_image_to_ppm(id, im2, s2);
		      Imlib_destroy_image(id, im2);
		      Imlib_destroy_image(id, im);
		      scr_asp = (root.w << 16) / root.h;
		      im_asp = (width << 16) / height;
		      if ((!(IN_RANGE(scr_asp, im_asp, 16000))) &&
			  ((width < 480) && (height < 360)))
			{
			  scalex = 0;
			  scaley = 0;
			  tile = 1;
			  keep_asp = 1;
			}
		      else if (IN_RANGE(scr_asp, im_asp, 16000))
			{
			  scalex = 1024;
			  scaley = 1024;
			  tile = 0;
			  keep_asp = 0;
			}
		      else if (im_asp > scr_asp)
			{
			  scalex = 1024;
			  scaley = 0;
			  tile = 0;
			  keep_asp = 1;
			}
		      else
			{
			  scalex = 0;
			  scaley = 1024;
			  tile = 0;
			  keep_asp = 1;
			}
		      icl.r = 0;
		      icl.g = 0;
		      icl.b = 0;
		      bg = CreateDesktopBG(s3, &icl, ss, tile, keep_asp,
					   512, 512, scalex, scaley,
					   NULL, 0, 0, 0, 0, 0);
		      AddItem(bg, bg->name, 0, LIST_TYPE_BACKGROUND);
		    }
		  else
		    ok = 0;
		}
	      if (ok)
		{
		  ImageClass         *ic = NULL;

		  ic = CreateIclass();
		  ic->name = duplicate("`");
		  ic->norm.normal = CreateImageState();
		  ic->norm.normal->im_file = duplicate(s3);
		  ic->norm.normal->unloadable = 1;
		  IclassPopulate(ic);
		  AddItem(ic, ic->name, 0, LIST_TYPE_ICLASS);
		  ac = CreateAclass(ss);
		  a = CreateAction(EVENT_MOUSE_UP, 0, 0, 0, 0, 0, NULL);
		  AddAction(ac, a);
		  AddToAction(a, ACTION_BACKGROUND_SET, duplicate(s3));
		  mi = CreateMenuItem(NULL, ic, ac, NULL);
		  AddItemToMenu(m, mi);
		}
	    }
	}
    }
  if (p)
    FreeProgressbar(p);
  if (list)
    freestrlist(list, num);
  EDBUG_RETURN(m);
}

Menu               *
CreateMenuFromFlatFile(char *name, MenuStyle * ms, char *file)
{
  Menu               *m;
  FILE               *f;
  char                s[4096];

/*  
 * char                ss[4096];
 * MenuItem           *mi;
 */

  EDBUG(5, "CreateMenuFromFlatFile");
  m = CreateMenu();
  m->name = duplicate(name);
  m->style = ms;
  f = fopen(file, "r");
  if (f)
    {
      while (fgets(s, 4096, f))
	{
	}
      fclose(f);
    }
  EDBUG_RETURN(m);
}

Menu               *
CreateMenuFromGnome(char *name, MenuStyle * ms, char *dir)
{
  Menu               *m, *mm;
  int                 i, num;
  char              **list, s[4096], ss[4096];
  MenuItem           *mi;
  FILE               *f;
  char               *lang, name_buf[20];

  EDBUG(5, "CreateMenuFromGnome");

  if ((lang = getenv("LANG")) != NULL)
    Esnprintf(name_buf, sizeof(name_buf), "Name[%s]=", lang);
  else
    name_buf[0] = '\0';

  m = CreateMenu();
  m->name = duplicate(name);
  m->style = ms;
  list = ls(dir, &num);
  for (i = 0; i < num; i++)
    {
      if ((strcmp(list[i], ".")) && (strcmp(list[i], "..")))
	{
	  Esnprintf(ss, sizeof(ss), "%s/%s", dir, list[i]);
	  if (isdir(ss))
	    {
	      Esnprintf(s, sizeof(s), "%s/%s:%s", dir, list[i], name);
	      mm = CreateMenuFromGnome(s, ms, ss);
	      mm->parent = m;
	      AddItem(mm, mm->name, mm->win, LIST_TYPE_MENU);
	      mi = CreateMenuItem(list[i], NULL, NULL, mm);
	      AddItemToMenu(m, mi);
	    }
	  else
	    {
	      f = fopen(ss, "r");
	      if (f)
		{
		  char               *iname = NULL, *exec = NULL, *texec = NULL,
		                     *tmp;
		  ActionClass        *ac = NULL;
		  Action             *a;
		  char               *en_name = NULL;

		  while (fgets(s, sizeof(s), f))
		    {
		      if (s[strlen(s) - 1] == '\n')
			s[strlen(s) - 1] = 0;
		      if (!strncmp(s, "Name=", strlen("Name=")))
			en_name = duplicate(&(s[strlen("Name=")]));
		      else if (name_buf[0] &&
			       !strncmp(s, name_buf, strlen(name_buf)))
			iname = duplicate(&(s[strlen(name_buf)]));
		      else if (!strncmp(s, "TryExec=", strlen("TryExec=")))
			texec = duplicate(&(s[strlen("TryExec=")]));
		      else if (!strncmp(s, "Exec=", strlen("Exec=")))
			exec = duplicate(&(s[strlen("Exec=")]));
		    }
		  if (iname)
		    {
		      if (en_name)
			Efree(en_name);
		    }
		  else
		    {
		      if (en_name)
			iname = en_name;
		    }
		  fclose(f);
		  if ((iname) && (exec))
		    {
		      tmp = NULL;
		      if (texec)
			tmp = pathtoexec(texec);
		      if ((tmp) || (!texec))
			{
			  if (tmp)
			    Efree(tmp);

			  ac = CreateAclass(ss);
			  a = CreateAction(EVENT_MOUSE_UP, 0, 0, 0, 0, 0, NULL);
			  AddAction(ac, a);
			  AddToAction(a, ACTION_EXEC, duplicate(exec));
			  mi = CreateMenuItem(iname, NULL, ac, NULL);
			  AddItemToMenu(m, mi);
			}
		    }
		  if (iname)
		    Efree(iname);
		  if (exec)
		    Efree(exec);
		  if (texec)
		    Efree(texec);
		}
	    }
	}
    }
  if (list)
    freestrlist(list, num);
  EDBUG_RETURN(m);
}

Menu               *
CreateMenuFromAllEWins(char *name, MenuStyle * ms)
{
  Menu               *m;
  EWin              **lst;
  int                 i, num;
  char                s[256];
  ActionClass        *ac = NULL;
  Action             *a;
  MenuItem           *mi;

  EDBUG(5, "CreateMenuFromEWins");
  m = CreateMenu();
  m->name = duplicate(name);
  m->style = ms;

  lst = (EWin **) ListItemType(&num, LIST_TYPE_EWIN);
  if (lst)
    {
      for (i = 0; i < num; i++)
	{
	  if ((!lst[i]->internal) && (!lst[i]->skipwinlist))
	    {
	      ac = CreateAclass(s);
	      a = CreateAction(EVENT_MOUSE_UP, 0, 0, 0, 0, 0, NULL);
	      AddAction(ac, a);
	      if (!lst[i]->sticky)
		{
		  Esnprintf(s, sizeof(s), "%i", lst[i]->desktop);
		  AddToAction(a, ACTION_GOTO_DESK, duplicate(s));
		}
	      Esnprintf(s, sizeof(s), "%i", (int)(lst[i]->client.win));
	      AddToAction(a, ACTION_FOCUS_SET, duplicate(s));
	      mi = CreateMenuItem(lst[i]->client.title, NULL, ac, NULL);
	      AddItemToMenu(m, mi);
	    }
	}
      Efree(lst);
    }
  EDBUG_RETURN(m);
}

Menu               *
CreateMenuFromDesktopEWins(char *name, MenuStyle * ms, int desk)
{
  Menu               *m;
  EWin              **lst;
  int                 i, num;
  char                s[256];
  ActionClass        *ac = NULL;
  Action             *a;
  MenuItem           *mi;

  EDBUG(5, "CreateMenuFromEWins");
  m = CreateMenu();
  m->name = duplicate(name);
  m->style = ms;

  lst = (EWin **) ListItemType(&num, LIST_TYPE_EWIN);
  if (lst)
    {
      for (i = 0; i < num; i++)
	{
	  if (((lst[i]->desktop == desk) || (lst[i]->sticky)) &&
	      (!lst[i]->internal) && (!lst[i]->skipwinlist))
	    {
	      ac = CreateAclass(s);
	      a = CreateAction(EVENT_MOUSE_UP, 0, 0, 0, 0, 0, NULL);
	      AddAction(ac, a);
	      Esnprintf(s, sizeof(s), "%i", (int)(lst[i]->client.win));
	      AddToAction(a, ACTION_FOCUS_SET, duplicate(s));
	      mi = CreateMenuItem(lst[i]->client.title, NULL, ac, NULL);
	      AddItemToMenu(m, mi);
	    }
	}
      Efree(lst);
    }
  EDBUG_RETURN(m);
  desk = 0;
}

Menu               *
CreateMenuFromDesktops(char *name, MenuStyle * ms)
{
  Menu               *m, *mm;
  EWin              **lst;
  int                 j, i, num;
  char                s[256];
  ActionClass        *ac = NULL;
  Action             *a;
  MenuItem           *mi;

  EDBUG(5, "CreateMenuFromEWins");
  m = CreateMenu();
  m->name = duplicate(name);
  m->style = ms;
  lst = (EWin **) ListItemType(&num, LIST_TYPE_EWIN);
  for (j = 0; j < mode.numdesktops; j++)
    {
      mm = CreateMenu();
      mm->name = duplicate("__SUBMENUDESK_E");
      mm->style = ms;
      Esnprintf(s, sizeof(s), "%i", j);
      ac = NULL;
      ac = CreateAclass(s);
      a = CreateAction(EVENT_MOUSE_UP, 0, 0, 0, 0, 0, NULL);
      AddAction(ac, a);
      AddToAction(a, ACTION_GOTO_DESK, duplicate(s));
      mi = CreateMenuItem("Go to this Desktop", NULL, ac, NULL);
      AddItemToMenu(mm, mi);
      for (i = 0; i < num; i++)
	{
	  if (((lst[i]->desktop == j) || (lst[i]->sticky)) &&
	      (!lst[i]->internal) && (!lst[i]->skipwinlist))
	    {
	      ac = NULL;
	      ac = CreateAclass(s);
	      a = CreateAction(EVENT_MOUSE_UP, 0, 0, 0, 0, 0, NULL);
	      AddAction(ac, a);
	      Esnprintf(s, sizeof(s), "%i", j);
	      AddToAction(a, ACTION_GOTO_DESK, duplicate(s));
	      Esnprintf(s, sizeof(s), "%i", (int)(lst[i]->client.win));
	      AddToAction(a, ACTION_FOCUS_SET, duplicate(s));
	      mi = CreateMenuItem(lst[i]->client.title, NULL, ac, NULL);
	      AddItemToMenu(mm, mi);
	    }
	}
      mm->parent = m;
      Esnprintf(s, sizeof(s), "Desktop %i", j);
      mi = CreateMenuItem(s, NULL, NULL, mm);
      AddItemToMenu(m, mi);
    }
  if (lst)
    Efree(lst);
  EDBUG_RETURN(m);
}

void
ShowMenuMasker(Menu * m)
{
  EWin               *ewin;

  ewin = FindEwinByMenu(m);
  if ((ewin) && (!mode.menu_cover_win))
    {
      Window              parent;
      Window              wl[2];

      parent = desks.desk[ewin->desktop].win;
      mode.menu_cover_win = ECreateEventWindow(parent, 0, 0, root.w, root.h);
      wl[0] = ewin->win;
      wl[1] = mode.menu_cover_win;
      XSelectInput(disp, mode.menu_cover_win, ButtonPressMask |
		   ButtonReleaseMask | EnterWindowMask | LeaveWindowMask);
      XRestackWindows(disp, wl, 2);
      XMapWindow(disp, mode.menu_cover_win);
    }
}

void
HideMenuMasker(void)
{
  if (mode.menu_cover_win)
    XDestroyWindow(disp, mode.menu_cover_win);
  mode.menu_cover_win = 0;
}
