
#include "E.h"

void
MapUnmap(int start)
{
  static Window      *wlist = NULL;
  Window              par;
  Window              rt;
  XWindowAttributes   attr;
  static unsigned int num = 0;
  unsigned int        i;

  EDBUG(6, "MapUnmap");
  switch (start)
    {
    case 0:
      XQueryTree(disp, root.win, &rt, &par, &wlist, &num);
      if (wlist)
	{
	  for (i = 0; i < num; i++)
	    {
	      if ((init_win_ext) && (init_win_ext == wlist[i]))
		wlist[i] = 0;
	      else
		{
		  XGetWindowAttributes(disp, wlist[i], &attr);
		  if (attr.map_state == IsUnmapped)
		    wlist[i] = 0;
		  else
		    XUnmapWindow(disp, wlist[i]);
		}
	    }
	}
      break;
    case 1:
      if (wlist)
	{
	  for (i = 0; i < num; i++)
	    {
	      if (wlist[i])
		{
		  if (XGetWindowAttributes(disp, wlist[i], &attr))
		    {
		      if (attr.override_redirect)
			{
			  if (init_win1)
			    {
			      XRaiseWindow(disp, init_win1);
			      XRaiseWindow(disp, init_win2);
			    }
			  if (init_win_ext)
			    XRaiseWindow(disp, init_win_ext);
			  RaiseProgressbars();
			  XMapWindow(disp, wlist[i]);
			}
		      else
			AddToFamily(wlist[i]);
		    }
		}
	    }
	  XFree(wlist);
	}
      break;
    default:
      break;
    }
  EDBUG_RETURN_;
}

void
SetupSignals()
{
  struct sigaction    sa;

  EDBUG(6, "SetupSignals");
  sa.sa_handler = HandleSigHup;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGHUP, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigInt;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGINT, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigQuit;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGQUIT, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigIll;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGILL, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigAbrt;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGABRT, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigFpe;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGFPE, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigSegv;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGSEGV, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigPipe;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGPIPE, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigAlrm;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGALRM, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigTerm;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGTERM, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigUsr1;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGUSR1, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigUsr2;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGUSR2, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigChild;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGCHLD, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigTstp;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGTSTP, &sa, (struct sigaction *)0);
  sa.sa_handler = HandleSigBus;
  sa.sa_flags = 0;
  sigemptyset(&sa.sa_mask);
  sigaction(SIGBUS, &sa, (struct sigaction *)0);
  EDBUG_RETURN_;
}

void
SetupX()
{
  int                 test_event_base, test_error_base, test_v1, test_v2;
  int                 shape_event_base, shape_error_base, i;

  EDBUG(6, "SetupX");
  /* Open a connection to the diplay nominated by the DISPLAY variable */
  disp = XOpenDisplay(NULL);
  /* if cannot connect to display */
  if (!disp)
    {
      Alert("Enlightenment cannot connect to the display nominated by\n"
	    "your shell's DISPLAY environment variable. You may set this\n"
	    "variable to indicate which display name Enlightenment is to\n"
	    "connect to. It may be that you do not have an Xserver already\n"
	    "running to serve that Display connection, or that you do not\n"
	    "have permission to connect to that display. Please make sure\n"
	    "all is correct before trying again. Run an Xserver by running\n"
	    "xdm or startx first, or contact your local system\n"
	    "administrator, or Xserver vendor, or read the X, xdm and\n"
	    "startx manual pages before proceeding.\n");
      EExit((void *)1);
    }
  /* set up an error handler for then E would normally have fatal X errors */
  XSetErrorHandler((XErrorHandler) EHandleXError);
  /* set up a handler for when the X Connection goes down */
  XSetIOErrorHandler((XIOErrorHandler) HandleXIOError);
  /* Check for the Shape Extension */
  if (!XShapeQueryExtension(disp, &shape_event_base, &shape_error_base))
    {
      Alert("FATAL ERROR:\n"
	    "This Xserver does not support the Shape extension.\n"
	    "This is required for Enlightenment to run.\n"
	    "Exiting.\n");
      EExit((void *)1);
    }
  /* check for the XTEST extension */
  if (XTestQueryExtension(disp, &test_event_base, &test_error_base, &test_v1, &test_v2))
    {
      /* make Enlightenment immune to other clients using XGrabServer */
/*      XTestGrabControl(disp, True); */
    }
  else
    Alert("WARNING:\n"
	  "This Xserver does not support the XTest extension.\n"
	  "This is required for Enlightenment to run properly.\n"
	  "Enlightenment will continue to run, but parts may not.\n"
	  "Work correctly.\n"
	  "Please contact your system administrator, or see the manuals\n"
	  "For your XServer to find out how to enable the XTest\n"
	  "Extension\n");
  /* record the event base for shape change events */
  event_base_shape = shape_event_base;
  /* initialise imlib */
  id = Imlib_init(disp);
  if (!id)
    {
      Alert("FATAL ERROR:\n"
	    "Enlightenment is unable to initialise Imlib.\n"
	    "Exiting.\n");
      EExit((void *)1);
    }
  fd = Fnlib_init(id);
  if (!fd)
    {
      Alert("FATAL ERROR:\n"
	    "Enlightenment is unable to initialise Fnlib.\n"
	    "Exiting.\n");
      EExit((void *)1);
    }
  root.win = id->x.root;
  root.vis = Imlib_get_visual(id);
  root.depth = id->x.depth;
  root.cmap = Imlib_get_colormap(id);
  root.scr = DefaultScreen(disp);
  root.w = DisplayWidth(disp, root.scr);
  root.h = DisplayHeight(disp, root.scr);
  root.focuswin = ECreateWindow(root.win, -100, -100, 5, 5, 0);
  /* warn, if necessary about visual problems */
  if (DefaultVisual(disp, root.scr) != root.vis)
    {
      ImlibInitParams     p;

/*      
 * Alert("WARNING:\n"
 * "The Visual used for the Root Window (Desktop Background) does\n"
 * "not match the visual that Imlib has chosen to use (which\n"
 * "will the the visual with the greatest bit depth / greatest\n"
 * "number of colours). This may result in backgrounds set by\n"
 * "Enlightenment either not working, or looking strange.\n"
 * "You can fix this by running your Xserver with its default\n"
 * "Visual being the one with the highest bit-depth. Please\n"
 * "refer to your Xserver manuals, or contact your system\n"
 * "administrator or Xserver vendor.\n");
 */
      p.flags = PARAMS_VISUALID;
      p.visualid = XVisualIDFromVisual(DefaultVisual(disp, root.scr));
      ird = Imlib_init_with_params(disp, &p);
    }
  else
    ird = NULL;
  /* just in case - set them up again */
  /* set up an error handler for then E would normally have fatal X errors */
  XSetErrorHandler((XErrorHandler) EHandleXError);
  /* set up a handler for when the X Connection goes down */
  XSetIOErrorHandler((XIOErrorHandler) HandleXIOError);
  /* slect all the root window events to start managing */
  XSelectInput(disp, root.win,
	       ButtonPressMask | ButtonReleaseMask |
	       EnterWindowMask | LeaveWindowMask | ButtonMotionMask |
	       PropertyChangeMask | SubstructureRedirectMask | KeyPressMask |
	       KeyReleaseMask | PointerMotionMask | ResizeRedirectMask |
	       SubstructureNotifyMask);
  {
    Atom                atom_set;
    CARD32              val;

    atom_set = XInternAtom(disp, "_WIN_DESKTOP_BUTTON_PROXY", False);
    bpress_win = ECreateWindow(root.win, -80, -80, 24, 24, 0);
    val = bpress_win;
    XChangeProperty(disp, root.win, atom_set, XA_CARDINAL, 32, PropModeReplace,
		    (unsigned char *)&val, 1);
    XChangeProperty(disp, bpress_win, atom_set, XA_CARDINAL, 32, PropModeReplace,
		    (unsigned char *)&val, 1);
  }

  XSync(disp, False);
  /* warn, if necessary about lack of multi-head support */
  if (ScreenCount(disp) > 1)
    {
      Alert("WARNING:\n"
	    "Your Xserver supports a multi-headed configuration with\n"
	    "multiple screens attached to the one display. Enlightenment\n"
	    "does not currently support multi-headed setups, and as a\n"
	    "result will only manage the first screen (this one).\n");
    }
  /* warn, if necessary about X version problems */
  if (ProtocolVersion(disp) != 11)
    {
      Alert("WARNING:\n"
	    "This is not an X11 Xserver. It infact talks the X%i protocol.\n"
	    "This may mean Enlightenment will either not function, or\n"
	    "function incorrectly. If it is later than X11, then your\n"
	    "server is one the author(s) of Enlightenment neither have\n"
	    "access to, nor have heard of.\n", ProtocolVersion(disp));
    }
  /* now we'll set the locale */
  setlocale(LC_ALL, "");
  if (!XSupportsLocale())
    {
/*      printf("locale not support by Xlib. locale set to C"); */
      setlocale(LC_ALL, "C");
    }
  XSetLocaleModifiers("");
  setlocale(LC_ALL, NULL);

  ICCCM_SetIconSizes();
  ICCCM_Focus(NULL);
  MWM_SetInfo();
  GNOME_SetHints();
  initFunctionArray();
  mode.mode = MODE_NONE;
  mode.destroy = 0;
  mode.adestroy = 0;
  mode.deskmode = MODE_NONE;
  mode.ewin = NULL;
  mode.button = NULL;
  mode.noewin = 0;
  mode.px = 0;
  mode.py = 0;
  mode.x = 0;
  mode.y = 0;
  mode.focusmode = FOCUS_SLOPPY;
  mode.focuswin = NULL;
  mode.realfocuswin = NULL;
  mode.mouse_over_win = NULL;
  mode.click_focus_grabbed = 0;
  mode.movemode = 0;
  mode.dockdirmode = DOCK_UP;
  mode.dockstartx = 0;
  mode.dockstarty = 0;
  mode.primaryicondir = ICON_RIGHT;
  mode.resizemode = 1;
  mode.slidemode = 0;
  mode.cleanupslide = 1;
  mode.mapslide = 1;
  mode.slidespeedmap = 4000;
  mode.slidespeedcleanup = 6000;
  mode.shadespeed = 4000;
  mode.doingslide = 0;
  mode.server_grabbed = 0;
  mode.desktop_bg_timeout = 240;
  mode.sound = 1;
  mode.button_move_resistance = 5;
  mode.button_move_pending = 0;
  mode.current_cmap = 0;
  mode.autosave = 1;
  mode.slideout = NULL;
  mode.tooltips = 1;
  mode.tiptime = 0.5;
  mode.autoraise = 0;
  mode.autoraisetime = 0.5;
  mode.memory_paranoia = 1;
  mode.save_under = 1;
  mode.cur_menu_mode = 0;
  mode.cur_menu_depth = 0;
  for (i = 0; i < 256; i++)
    mode.cur_menu[i] = NULL;
  mode.menuslide = 0;
  mode.numdesktops = ENLIGHTENMENT_CONF_NUM_DESKTOPS;
  mode.transientsfollowleader = 1;
  mode.switchfortransientmap = 1;
  mode.showicons = 1;
  mode.snap = 1;
  mode.edge_snap_dist = 8;
  mode.screen_snap_dist = 32;
  mode.menu_cover_win = 0;

  desks.dragdir = 2;
  desks.dragbar_width = 16;
  desks.dragbar_ordering = 1;
  desks.dragbar_length = 0;
  desks.slidein = 1;
  desks.slidespeed = 3200;
  desks.hiqualitybg = 1;
  SetAreaSize(3, 3);

  for (i = 0; i < ENLIGHTENMENT_CONF_NUM_DESKTOPS; task_menu[i++] = NULL);

  EDBUG_RETURN_;
}

void
SetupDirs()
{
  char               *home;
  char                s[1024], ss[1024];

  EDBUG(6, "SetupDirs");
  home = homedir(getuid());
  Esnprintf(s, sizeof(s), "%s/.enlightenment", home);
  if (!home)
    EDBUG_RETURN_;
  if (exists(s))
    {
      if (isfile(s))
	{
	  Alert("%s is a file not a directory. %s will be renamed %s.old and\n"
		"a %s directory will be created.\n", s, s, s);
	  Esnprintf(ss, sizeof(ss), "%s/.enlightenment.old", home);
	  mv(s, ss);
	  md(s);
	}
    }
  else
    {
      md(s);
      Alert("This is just a friendly message that the following directory:\n"
	    "%s\n"
	    "has been created by Enlightenment. You are free to change the\n"
	    "permissions on it as you please, as long as you are able to\n"
	    "read and write to the directory's contents, which Enlightenment\n"
	    "will fill with user-dependant information as time goes on.\n", s);
    }
  if (home)
    Efree(home);
  EDBUG_RETURN_;
}

void
SetupEnv()
{
  char                s[1024];

  Esetenv("EVERSION", ENLIGHTENMENT_VERSION, 1);
  Esetenv("EROOT", ENLIGHTENMENT_ROOT, 1);
  Esnprintf(s, sizeof(s), "%i", getpid());
  Esetenv("EPID", s, 1);
  Esetenv("ETHEME", themepath, 1);
}

Window
MakeExtInitWin(void)
{
  Display            *d2;
  Window              win;
  XGCValues           gcv;
  GC                  gc;
  Pixmap              pmap;
  Atom                a, aa;
  CARD32              val;
  XEvent              ev;
  int                 format_ret;
  unsigned long       bytes_after, num_ret;
  Window             *retval;
  XSetWindowAttributes attr;

  a = XInternAtom(disp, "ENLIGHTENMENT_RESTART_SCREEN", False);
  XSync(disp, False);
  if (fork())
    {
      UngrabX();
      for (;;)
	{
	  retval = NULL;
	  XGetWindowProperty(disp, root.win, a, 0, 0x7fffffff, True,
			     XA_CARDINAL, &aa, &format_ret, &num_ret,
			     &bytes_after, (unsigned char **)(&retval));
	  XSync(disp, False);
	  if (retval)
	    break;
	}
      win = *retval;
      fflush(stdout);
      XFree(retval);
      return win;
    }
  XSetErrorHandler((XErrorHandler) NULL);
  XSetIOErrorHandler((XIOErrorHandler) NULL);
  signal(SIGHUP, SIG_DFL);
  signal(SIGINT, SIG_DFL);
  signal(SIGQUIT, SIG_DFL);
  signal(SIGILL, SIG_DFL);
  signal(SIGABRT, SIG_DFL);
  signal(SIGFPE, SIG_IGN);
  signal(SIGSEGV, SIG_IGN);
  signal(SIGPIPE, SIG_DFL);
  signal(SIGALRM, SIG_DFL);
  signal(SIGTERM, SIG_DFL);
  signal(SIGUSR1, SIG_DFL);
  signal(SIGUSR2, SIG_DFL);
  signal(SIGCHLD, SIG_DFL);
  signal(SIGTSTP, SIG_DFL);
  signal(SIGBUS, SIG_IGN);
  d2 = XOpenDisplay(NULL);
  XGrabServer(d2);
  attr.backing_store = NotUseful;
  attr.override_redirect = True;
  attr.colormap = root.cmap;
  attr.border_pixel = 0;
  attr.background_pixel = 0;
  attr.save_under = True;
  win = XCreateWindow(d2, root.win, 0, 0, root.w, root.h, 0, root.depth,
		      InputOutput, root.vis, CWOverrideRedirect | CWSaveUnder |
		    CWBackingStore | CWColormap | CWBackPixel | CWBorderPixel,
		      &attr);
  pmap = XCreatePixmap(d2, win, root.w, root.h, root.depth);
  gcv.subwindow_mode = IncludeInferiors;
  gc = XCreateGC(d2, win, GCSubwindowMode, &gcv);
  XCopyArea(d2, root.win, pmap, gc, 0, 0, root.w, root.h, 0, 0);
  XSetWindowBackgroundPixmap(d2, win, pmap);
  XMapRaised(d2, win);
  XFreePixmap(d2, pmap);
  XFreeGC(d2, gc);
  val = win;
  XChangeProperty(d2, root.win, a, XA_CARDINAL, 32,
		  PropModeReplace, (unsigned char *)&val, 1);
  XSelectInput(d2, win, StructureNotifyMask);
  XUngrabServer(d2);
  XSync(d2, False);
  for (;;)
    XNextEvent(d2, &ev);
  exit(0);
}
